PIDOF(8)

NOM
pidof – afficher l’identifiant de processus d'un programme en cours

SYNOPSIS
pidof [-s] [-c] [-n] [-x] [-z] [-o omitpid[,omitpid...]] [-o omitpid[,omitpid...]...] [-d sep] program [program...]

DESCRIPTION
pidof cherche les identifiants de processus (PID : « Process ID ») portant l'un des noms de programme indiqués. Il affiche ces identifiants sur sa sortie standard. Ce programme est utilisé sur certains systèmes dans les scripts de changement de niveau d'exécution, en particulier pour les systèmes utilisant la structure rc de Système V. Dans ce cas, ces scripts sont situés dans /etc/rc?.d où « ? » est le niveau d'exécution. Si le système possède le programme start-stop-daemon(8), celui-ci devrait être utilisé à la place.

OPTIONS

-s  Un seul essai – pidof ne renverra qu'un seul pid.

-c  Ne renvoyer que les identifiants des processus qui sont exécutés dans le même répertoire racine. Cette option est ignorée pour les utilisateurs autres que le superutilisateur puisqu'ils ne peuvent pas vérifier le répertoire racine en cours des processus dont ils ne sont pas propriétaires.

-n  Éviter l'appel à la fonction système stat(2) pour tous les binaires situés sur des systèmes de fichiers en réseau comme NFS. Au lieu d'utiliser cette option, il est possible de configurer et d'exporter la variable PIDOF_NETFS.

-q  Ne pas afficher les PID qui correspondent sur la sortie standard. Simplement quitter avec l’état vrai ou faux pour indiquer si un PID correspondant a été trouvé.

-x  Scripts également – pidof renverra également les PID des interpréteurs de commandes exécutant les scripts indiqués.

-z  Try to detect processes which are stuck in zombie (Z) status. Usually these processes are skipped as trying to deal with them can cause pidof or related tools to hang. Note: In the past pidof would ignore processes in the uninterruptable state (D), unless the -z flag was specified. This is no longer the case. The pidof program will find and report processes in the D state whether -z is specified or not.

-d sep
    Demander à pidof d’utiliser sep comme séparateur de sortie si plus d’un PID est affiché. Le séparateur par défaut est une espace.

-o sauf_pid
    Demander à pidof de ne pas tenir compte du processus du PID indiqué. Le PID spécial %PPID peut décrire le processus parent du programme pidof, c'est-à-dire l’interpréteur de commandes ou le script d’interpréteur appelant.

CODE DE RETOUR

0   Au moins un programme a été trouvé avec le nom demandé.

1   Aucun programme n’a été trouvé avec le nom demandé.

NOTES
pidof utilise en fait le même programme que killall5(8) ; la différence de comportement se fait en fonction du nom du programme appelé.

Quand pidof est exécuté avec le chemin complet du programme dont il doit chercher le PID, son comportement est fiable. Dans le cas contraire, les PID renvoyés peuvent être ceux de processus portant le même nom mais qui sont en fait des programmes différents. Notez que le nom de l'exécutable des processus en cours d'exécution est obtenu à l'aide de readlink(2), et donc les liens symboliques vers les exécutables correspondront également.

Les processus zombies ou les processus de disque en veille (états Z et D respectivement) sont ignorés car les essais d’accès à leurs états échouera parfois. L’argument -z (voir ci-dessus) demande à pidof d’essayer de détecter ces processus zombies ou en veille avec le risque d’échouer ou de planter.

VOIR AUSSI
shutdown(8), init(8), halt(8), reboot(8), killall5(8)

AUTEUR
Miquel van Smoorenburg (miquels@cistron.nl)